/*--------------------------------------------------------------------------*/
/*                                                                          */
/*      Filename:                                                           */
/*                                                                          */
/*      Project:                                                            */
/*                                                                          */
/*      Description:                                                        */
/*                                                                          */
/*      Author:                                                             */
/*                                                                          */
/*      History:                                                            */
/*                                                                          */
/*--------------------------------------------------------------------------*/
/*                                                                          */
/*      (C) Copyright EMASS, Inc. 1996                                      */
/*                                                                          */
/*--------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------*/
/* Adjust next 2 definitions for every new release...                       */
/*--------------------------------------------------------------------------*/
VERSION = "1.3C12 "
DASFILE = "DAS*.ZIP"

BACKUP_DIR = "C:\DAS\DAS_SAVE"
BACKUP_BIN = "C:\DAS\DAS_SAVE\BIN"
BACKUP_ETC = "C:\DAS\DAS_SAVE\ETC"
BACKUP_TOOLS = "C:\DAS\DAS_SAVE\TOOLS"

CONFIG_SYS = "C:\CONFIG.SYS"
CONFIG_DAS = "C:\CONFIG.DAS"
CONFIG_NEW = "C:\CONFIG.NEW"

STARTUP_SAMPLE = "C:\das\tools\startup.smp"

/*--------------------------------------------------------------------------*/
/*  Environment variables for and DAS                                       */
/*--------------------------------------------------------------------------*/
DASPATHLINE1 = "SET DAS_SERVER=AMU"
DASPATHLINE2 = "SET DAS_CLIENT=AMUCLIENT"

/*--------------------------------------------------------------------------*/
/*  Damit 'n paar gute Funktionalitten zur Verfgung stehen ...            */
/*--------------------------------------------------------------------------*/
call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
call SysLoadFuncs

/*--------------------------------------------------------------------------*/
/*  dann noch n paar Tne                                                   */
/*--------------------------------------------------------------------------*/
viertel = 400
achtel  = viertel / 2
sechzehntel = achtel / 2
achtelpkt = achtel + sechzehntel
note.1 = 262    /* middle C */
note.2 = 294    /*    D     */
note.3 = 330    /*    E     */
note.4 = 349    /*    F     */
note.5 = 392    /*    G     */
note.6 = 440    /*    A     */
note.7 = 494    /*    B     */
note.8 = 524    /*    C     */

Install_Directory    = directory()
Floppy_Inst   = 0               /* Installation from floppy                   */
Floppy_Inst          = compare(Install_Directory, 'A:\')


/****************************************************************************\
  Hier beginnt das Hauptmenue. Dreimal kann eingeben werden, dann ist Schlu
\****************************************************************************/
INST_UTL_DATE = stream(Install_Directory'\dasinst.cmd', 'c', 'query datetime')

'@echo off'
DO 3
  call SysCls
  say ""
  say "Ŀ"
  say "      ADIC, AMU-Service, "INST_UTL_DATE"                              "
  say "                                                                      "
  say "              I N S T A L L A T I O N     U T I L I T Y               "
  say "                  DAS  -  V E R S I O N  " VERSION"                       "
  say "                                                                      "
  say " 1 = New Installation of DAS Server Software                          "
  say "     (Installation without backup of an older Version)                "
  say "                                                                      "
  say " 2 = DAS Software Update from DAS 1.3x to DAS" VERSION"                   "
  say "                                                                      "
  say " 3 = DAS Software Update from DAS 1.20x to DAS" VERSION"                  "
  say "                                                                      "
  say " 4 = End                                                              "
  say "                                                                      "
  say "                                                                      "
  say " Select an Option:                                                    "
  say ""
  cpos = SysCurPos(17,20)
  Option = translate(SysGetKey('NOECHO'))
  cls
  say ""
  say ""
  if Option = "1" then
  do
    call DasInstall
    call config_update
    call GoodEnd
  end

  if Option = "2" then
  do
    call Backup
    call DasUpdate
    call config_update
    call GoodEnd
  end

  if Option = "3" then
  do
    call Backup
    call DasUpdate
    call convert_config
    call config_update
    call GoodEnd
  end

  if Option = "4" then
  do
    cls
    EXIT
  end
end
EXIT


/************************************+***************************************/
/*                           Function BACKUP                                */
/************************************+***************************************/
Backup:
say "INFO: Backup - directory will be created..."
newdir = directory( "C:/" )
newdir = "C:\"
rc  = SysMkDir(BACKUP_DIR)
rc1 = SysMKDir(BACKUP_ETC)
rc2 = SysMKDir(BACKUP_TOOLS)
rc3 = SysMKDir(BACKUP_BIN)

if ( ( (rc = 0)|(rc = 5) ) & ( (rc1 = 0)|(rc1 = 5) ) & ( (rc2 = 0)|(rc2 = 5) ) & ( (rc3 = 0)|(rc3 = 5) ) ) then
 do
   say "INFO: DAS backup directory successfully created."
 end
else
 do
   say "ERROR: Unable to create backup directory for existing DAS installation."
   SIGNAL ENDE
 end
 

newdir = directory( "C:/das" )
if newdir = "C:\das" then
do
  say "INFO: Saving DAS-directory..."
  copy "*.*" BACKUP_DIR 
  xcopy ".\bin" BACKUP_BIN "/s"
  xcopy ".\etc" BACKUP_ETC "/s"
  xcopy ".\tools" BACKUP_TOOLS "/s"
  del "*.zip"
  say ""
end
else
do
  say ""
  say "ERROR: Unable to change to DAS directory."
  say ""
  SIGNAL ENDE
end
say "INFO: DAS directory saved."
say ""
return

/************************************+***************************************/
/*                           Function CONFIG_UPDATE                         */
/************************************+***************************************/
config_update:
say "INFO: Saving the current CONFIG.SYS file..."
copy  CONFIG_SYS CONFIG_DAS
if rc > 0 then
do
  call beep note.1,250
  say ""
  say "ATTENTION: A backup of your CONFIG.SYS already exists and"
  say "           it is already write protected!"
  say ""
  say "           Do you still want to make a backup of the file"
  say "           CONFIG.SYS into the file CONFIG.DAS? (Y/N)"
  say ""

  Answer = translate(SysGetKey('ECHO'))
  if Answer = 'y' | Answer = 'Y' then
  do
    attrib "C:\CONFIG.DAS -r"
    copy  CONFIG_SYS CONFIG_DAS
    attrib "C:\CONFIG.DAS +r"
    say ""
    say "INFO: Backup of CONFIG.SYS written to CONFIG.DAS"
    say "      and set to read only."
  end
  else
  do
    say ""
    say "INFO: Backup of CONFIG.SYS not written to CONFIG.DAS!"
  end
end
else
do
  say ""
  say "INFO: Trying to protect the backup CONFIG.SYS (CONFIG.DAS)"
  say "      from being overwritten."
  attrib "C:\CONFIG.DAS +r"
end
say ""

/*--------------------------------------------------------------------------*/
/*  Ueberpruefung LIBPATH, PATH, HELP, AMUPATH, QUADRON und DAS Environment */
/*--------------------------------------------------------------------------*/
LIBPATHUPDT = 0
DASSERVERSET = 0
DASCLIENTSET = 0

i = linein(CONFIG_NEW, 1, 0)
ret = 1
do while ret = 1
  DONEALINE = 0
  aline = linein(CONFIG_SYS)

  /*------------------------------------------------------------------------*/
  /* Setzen des LIBPATH fuer DAS ACI.DLL                                    */
  /*------------------------------------------------------------------------*/
  if LIBPATHUPDT = 0 then
  do
    i = compare( 'LIBPATH', aline)
    if i >= 8 then
    do
      p = pos("C:\DAS\ADMIN;",aline)
      q = pos("C:\DAS\BIN;",aline)
      i = length( aline )
      if p = 0 then
      do
        if q = 0 then
        do
          say "INFO: LIBPATH for DAS not found."
          c = SUBSTR(aline, i, 1)
          if c = ';' then
          do
            newline = insert( "C:\DAS\BIN;", aline, i )
            say "INFO: LIBPATH for DAS added."
          end
          else
          do
            newline = insert( ";C:\DAS\BIN;", aline, i )
            say "INFO: LIBPATH for DAS added."
          end
        end
        else
        do
          newline = insert( "", aline, i )
          say "INFO: LIBPATH for DAS already exists."
        end
      end
      else
      do
        newline = SUBSTR(aline, 1, p-1)
        j = p+13
        i = length( aline )
        c = SUBSTR(aline, j, i-j+1)
        newline = insert( c, newline, p-1 )
        if q = 0 then
        do
          i = length( newline )
          aline = SUBSTR( newline, 1, i )
          c = SUBSTR(aline, i, 1)
          if c = ';' then
          do
            newline = insert( "C:\DAS\BIN;", aline, i )
          end
          else
          do
            newline = insert( ";C:\DAS\BIN;", aline, i )
          end
          say "INFO: Removed old DAS path. New LIBPATH for DAS added."
        end
        else
        do
          say "INFO: Removed old DAS path. New LIBPATH for DAS already exists."
        end
      end
      i = lineout(CONFIG_NEW, newline)
      DONEALINE = 1
      LIBPATHUPDT = 1
    end
  end

  /*------------------------------------------------------------------------*/
  /* Ueberpruefung des DAS SERVER und CLIENT PATH                           */
  /*------------------------------------------------------------------------*/
  if DONEALINE = 0 then
  do
    if DASSERVERSET = 0 then
    do
      i = compare('SET DAS_SERVER',aline)
      if i >= 15 then
      do
        DASSERVERSET = 1
        say "INFO: DAS SERVER PATH already exists."
      end
    end
    if DASCLIENTSET = 0 then
    do
      i = compare('SET DAS_CLIENT',aline)
      if i >= 15 then
      do
        DASCLIENTSET = 1
        say "INFO: DAS CLIENT PATH already exists."
      end
    end
    i = lineout(CONFIG_NEW, aline)
  end
  ret = lines(CONFIG_SYS)
end
i = lineout(CONFIG_SYS)

/*--------------------------------------------------------------------------*/
/* Setzen des DAS SERVER PATH                                               */
/*--------------------------------------------------------------------------*/
if DASSERVERSET = 0 then
do
  i = lineout(CONFIG_NEW, DASPATHLINE1)
  say "INFO: DAS SERVER PATH added."
end

/*------------------------------------------------------------------------*/
/* Setzen des DAS CLIENT PATH                                             */
/*------------------------------------------------------------------------*/
if DASCLIENTSET = 0 then
do
  i = lineout(CONFIG_NEW, DASPATHLINE2)
  say "INFO: DAS CLIENT PATH added."
end

i = lineout( CONFIG_NEW )
say ""
copy CONFIG_NEW CONFIG_SYS
if rc = 0 then
do
  del CONFIG_NEW
  say "INFO: The CONFIG.SYS was updated. Changes will be activated on reboot."
end
else
do
  say "INFO: The CONFIG.SYS cannot be updated. Changes are stored in CONFIG.NEW."
end
say ""
return


/************************************+***************************************/
/*                           Function CONVERT_CONFIG                        */
/************************************+***************************************/
convert_config:
newdir = directory( "C:/DAS/ETC" )
if newdir = "C:\DAS\ETC" then
do
  say "INFO: Checking DAS configuration file..."
  copy "CONFIG CONFIG.OLD"
  if rc = 0 then
  do
    del "CONFIG"
    say ""
    i = linein(CONFIG, 1, 0)
    ret = 1
    AS = 0
    AM = 0
    READY = 0
    say "INFO: Converting DAS 1.20x config file..."
    say ""
    do while ret = 1
      aline = linein(CONFIG.OLD)
      if READY = 0 then
      do
        p = pos("client_name ",aline)
        if p = 0 then
        do
        end
        else
        do
          READY = 1
          i = lineout(CONFIG, aline)
        end
      end
      else
      do
        p = pos("AMPEX-SMALL",aline)
        if p = 0 then
        do
          p = pos("AMPEX-MEDIUM",aline)
          if p = 0 then
          do
            i = lineout(CONFIG, aline)
          end
          else
          do
            AM = 1
            if AS = 0 then
            do
              newline = SUBSTR(aline, 1, p-1)
              i = length( newline )
              c = insert( "AMPEX       ", newline, i )
              j = p+12
              i = length( aline )
              newline = SUBSTR(aline, j, i-j+1)
              i = length( c )
              aline = insert( newline, c, i )
              i = lineout(CONFIG, aline)
            end
          end
        end
        else
        do
          AS = 1
          if AM = 0 then
          do
            newline = SUBSTR(aline, 1, p-1)
            i = length( newline )
            c = insert( "AMPEX      ", newline, i )
            j = p+11
            i = length( aline )
            newline = SUBSTR(aline, j, i-j+1)
            i = length( c )
            aline = insert( newline, c, i )
            i = lineout(CONFIG, aline)
          end
        end
      end
      ret = lines(CONFIG.OLD)
    end
    i = lineout(CONFIG)
    i = lineout(CONFIG.OLD)
  end
  else
  do
    say ""
    say "ERROR: DAS\ETC\CONFIG file not found. Conversion of CONFIG failed!"
  end
end
else
do
  say ""
  say "INFO: DAS\ETC directory not found. Conversion of CONFIG failed!"
end
say ""
return


/************************************+***************************************/
/*                           Function DASINSTALL                            */
/************************************+***************************************/
DasInstall:
File = Install_Directory"\"DASFILE
DiskName = "OS/2_DAS_SERVER_SOFTWARE"
If Floppy_Inst = 0 then call DiskRequest File DiskName

/*--------------------------------------------------------------------------*/
/* Create DAS Directories                                                   */
/*--------------------------------------------------------------------------*/
newdir = directory( "C:/" )
if newdir = "C:\" then
do
  rc = SysMkDir( "DAS" )
  if rc = 0 then
  do
    say "INFO: DAS directory successfully created."
  end
  else
  do
    say "INFO: DAS directory could not be created!"
  end
end

/*--------------------------------------------------------------------------*/
/* Install DAS files...                                                     */
/*--------------------------------------------------------------------------*/
newdir = directory( "C:/DAS" )
if newdir = "C:\DAS" then
do
  say "INFO: Copying DAS Server software from diskette..."
  copy Install_Directory"\unzip.exe c:\das"
  if rc = 0 then
  do
    copy Install_Directory"\"DASFILE "C:\DAS\"DASFILE
    if rc = 0 then
    do
      unzip "-o " DASFILE
      if rc = 0 then
      do
        copy "C:\DAS\ETC\config.smp C:\DAS\ETC\config"
        say "INFO: DAS server installation completed successfully."
      end
      else
      do
        say "ERROR: DAS server installation failed..."
        say "       DAS server software could not be unzipped."
        signal ENDE
      end
      del "unzip.exe"
    end
    else
    do
      say "ERROR: DAS server installation failed..."
      say "       DAS server software could not be copied from diskette."
      signal ENDE
    end
  end
  else
  do
    say "ERROR: DAS server update failed..."
    say "       DAS cannot be unzipped because "Install_Directory"\UNZIP.EXE was not found."
    signal NOUNZIP
  end
end
else
do
  say "ERROR: DAS Server Software installation to C:\DAS failed!"
  say "       DAS needs to be installed manually in C:\DAS directory."
  signal ENDE
end
say ""
return

/************************************+***************************************/
/*                           Function DASUPDATE                             */
/************************************+***************************************/
DasUpdate:
newdir = directory( "C:/das" )
if newdir = "C:\das" then
do
  File = Install_Directory"\"DASFILE
  DiskName = "OS/2_DAS_SERVER_SOFTWARE"
  If Floppy_Inst = 0 then call DiskRequest File DiskName
  say "INFO: Copying DAS Server software from diskette..."
  copy Install_Directory"\unzip.exe"
  if rc = 0 then
  do
    copy Install_Directory"\"DASFILE "C:\DAS\"DASFILE
    if rc = 0 then
    do
      unzip "-o "DASFILE
      if rc = 0 then
      do
        say "INFO: DAS server update completed succesfully."
      end
      else
      do
        say "ERROR: DAS server update failed..."
        say "       DAS server software could not be unzipped."
        signal ENDE
      end
      del "unzip.exe"
    end
    else
    do
      say "ERROR: DAS server update failed..."
      say "       DAS server software could not be copied from diskette."
      signal ENDE
    end
  end
  else
  do
    say "ERROR: DAS server update failed..."
    say "       DAS cannot be unzipped because "Install_Directory"\UNZIP.EXE was not found."
    signal NOUNZIP
  end
end
else
do
  say "ERROR: DAS server update failed..."
  say "       DAS directory was not found."
  signal ENDE
end
say ""
return


/************************************+***************************************/
/*                           Function DISKREQUEST                           */
/************************************+***************************************/
DiskRequest:
parse arg File Diskname
say ""
DiskIsCorrect = 0
do until DiskIsCorrect = 1
  say 'INFO: Searching for file ' File
  call SysFileTree file, 'datei', 'F'
  if datei.0 = 0 then
  do
    say ""
    say "INFO: DAS software file was not found!"
    call beep note.1,250
    say 'Insert 'Diskname', DISK 1 of 1, into drive A:'
    say "Press <CR> when ready..."
    pull answer
    DiskIsCorrect = 0
  end
  else
  do
    DiskIsCorrect = 1
    say "INFO: DAS software file was found."
  end
end
return

/************************************+***************************************/
/*                           Function ANSWERYN                              */
/************************************+***************************************/
AnswerYN:
parse arg question
call beep note.1,250
say ""
say question
AnswerIsYN = 0
do while AnswerIsYN = 0
  parse upper pull answer
  if answer = 'Y' | answer = 'N' then
  do
    AnswerIsYN = 1
  end
  else
  do
    call beep note.1,250
    say "Please enter only Y or N then <CR>..."
    say""
  end
end
return answer


/************************************+***************************************/
/*                           Function GOODEND                               */
/************************************+***************************************/
GOODEND:
call beep note.1,viertel
call beep note.5,viertel
call beep note.5,viertel
call beep note.4,achtel
call beep note.3,achtel
call beep note.4,achtel
call beep note.3,achtel
call beep note.2,viertel
call beep note.2,viertel
call beep note.1,achtel
call beep note.2,achtel
call beep note.3,viertel
call beep note.2,achtel
call beep note.3,achtel
call beep note.4,viertel
call beep note.3,achtel
call beep note.1,achtel
call beep note.3,achtelpkt
call beep note.2,sechzehntel
call beep note.2,viertel
cls
say ""
say "               END OF SUCCESSFUL DAS-SOFTWARE INSTALLATION"
say "                          !CONGRATULATIONS!"
say ""
say "   Add the following statements to the end of your startup.cmd file to"
say "   automatically start the AMU AMS and DAS server software:"
say ""
type STARTUP_SAMPLE
say ""
say "   Make sure the DAS server software is configured correctly."
say "   Check your CONFIG.SYS, TCPIP\ETC\HOSTS, and DAS\ETC\CONFIG file!"
say "   Assure that TCP/IP is configured correctly and the portmapper started!"
newdir = directory( "C:\" )
EXIT


/************************************+***************************************/
/*                           Function NOUNZIP                               */
/************************************+***************************************/
NOUNZIP:
say ""
say "ERROR: UNZIP.EXE not found!"
say "       Obtain a copy of UNZIP.EXE, copy it to the DAS diskette"
say "       and retry the DAS installation."
say ""
SIGNAL ENDE


/************************************+***************************************/
/*                           Function ENDE                                  */
/************************************+***************************************/
ENDE:
call beep note.1,250
say ""
say ""
say "                     A severe error occurred..."
say ""
say "          DAS installation did not complete successfully!"
say "      Contact your DAS support representative for assistance."
say ""
newdir = directory( "C:\" )
EXIT

